- Book Chapter
109
- 10.1016/s0304-0208(08)72960-8
Linear Algebra in Dioids: A Survey of Recent Results
- Jan 01, 1984
- North-Holland Mathematics Studies
- Michel Gondran + 1 more +1
Linear Algebra in Dioids: A Survey of Recent Results
This chapter is concerned with the Boolean matrix approach to problems concerning the existence and determination of paths in directed graphs.
Linear Algebra in Dioids: A Survey of Recent Results
Linear Algebra in Dioids: A Survey of Recent Results
A Graphical Model for Context-Free Grammar Parsing
In the compiler literature, parsing algorithms for context-free grammars are presented using string rewriting systems or abstract machines such as pushdown automata. Unfortunately, the resulting descriptions can be baroque, and even a basic understanding of some parsing algorithms, such as Earley’s algorithm for general context-free grammars, can be elusive. In this paper, we present a graphical representation of context-free grammars called the Grammar Flow Graph (GFG) that permits parsing problems to be phrased as path problems in graphs; intuitively, the GFG plays the same role for context-free grammars that nondeterministic finite-state automata play for regular grammars. We show that the GFG permits an elementary treatment of Earley’s algorithm that is much easier to understand than previous descriptions of this algorithm. In addition, look-ahead computation can be expressed as a simple inter-procedural dataflow analysis problem, providing an unexpected link between front-end and back-end technologies in compilers. These results suggest that the GFG can be a new foundation for the study of context-free grammars.
Read moreHeavy path based super-sequence frequent pattern mining on web log dataset
Mining web log datasets has been extensively studied using Frequent Pattern Mining (FPM) and its various other forms. Identifyingfrequent patterns in different sequences can help in analyzing the most common sub-sequences (e.g., the pages visitedtogether). However, this approach would not be able to identify general structures spanning over multiple sequences. In responseto understanding general structures, we introduce a new form of sequential pattern mining called super-sequence frequent patternmining (SS-FPM). In contrast to sub-sequences determined by FPM, SS-FPM determines the super-sequences that can containthe common parts from different sequences. This can be useful in understanding the general behavior/flow of users in web usagemining, classifying web pages and users, making predictions etc. In essence, finding frequent super-sequence patterns turnsout to be related to the well-known heaviest (longest) path problem in graphs, which is known to be NP-hard. Accordingly,we transform a given sequential dataset into a sequence graph and formulate the problem as k-hop heaviest path problem. Wethen propose an efficient heuristic called sequence matrix method using dynamic programming techniques. We compared ourmethod to the existing Heavypath method. The results show that our method is more efficient especially on large datasets.
Read moreImproved approximation bounds for the minimum constraint removal problem
In the minimum constraint removal problem, we are given a set of overlapping geometric objects as obstacles in the plane, and we want to find the minimum number of obstacles that must be removed to reach a target point t from the source point s by an obstacle-free path. The problem is known to be intractable and no sub-linear approximations are known even for simple obstacles such as rectangles and disks. The main result of our paper is an approximation framework that gives an O(nα(n))-approximation for polygonal obstacles, where α(n) denotes the inverse Ackermann's function. For pseudodisks and rectilinear polygons, the same technique achieves an O(n)-approximation. The technique also gives O(n)-approximation for the minimum color path problem in graphs. We also present some inapproximability results for the geometric constraint removal problem.
Read moreFine-grained complexity for sparse graphs
We consider the fine-grained complexity of sparse graph problems that currently have O(mn) time algorithms, where m is the number of edges and n is the number of vertices in the input graph. This class includes several important path problems on both directed and undirected graphs, including APSP, MWC (Minimum Weight Cycle), Radius, Eccentricities, BC (Betweenness Centrality), etc. We introduce the notion of a sparse reduction which preserves the sparsity of graphs, and we present near linear-time sparse reductions between various pairs of graph problems in the O(mn) class. There are many sub-cubic reductions between graph problems in the O(mn) class, but surprisingly few of these preserve sparsity. In the directed case, our results give a partial order on a large collection of problems in the O(mn) class (along with some equivalences), and many of our reductions are very nontrivial. In the undirected case we give two nontrivial sparse reductions: from MWC to APSP, and from unweighted ANSC (all nodes shortest cycles) to unweighted APSP. We develop a new ‘bit-sampling’ method for these sparse reductions on undirected graphs, which also gives rise to improved or simpler algorithms for cycle finding problems in undirected graphs. We formulate the the notion of MWC hardness, which is based on the assumption that a minimum weight cycle in a directed graph cannot be computed in time polynomially smaller than mn. Our sparse reductions for directed path problems in the O(mn) class establish that several problems in this class, including 2-SiSP (second simple shortest path), s-t Replacement Paths, Radius, Eccentricities and BC are MWC hard. Our sparse reductions give MWC hardness a status for the O(mn) class similar to 3SUM hardness for the quadratic class, since they show sub-mn hardness for a large collection of fundamental and well-studied graph problems that have maintained an O(mn) time bound for over half a century. We also identify Eccentricities and BC as key problems in the O(mn) class which are simultaneously MWC-hard, SETH-hard and k-DSH-hard, where SETH is the Strong Exponential Time Hypothesis, and k-DSH is the hypothesis that a dominating set of size k cannot be computed in time polynomially smaller than nk. Our framework using sparse reductions is very relevant to real-world graphs, which tend to be sparse and for which the O(mn) time algorithms are the ones typically used in practice, and not the O(n3) time algorithms.
Read moreOptimizing multi-criteria k-shortest paths in graph by a natural routing genotype-based genetic algorithm
k-shortest path problem (KSP) is a more general form of the classical shortest path problem in graph. Its task is no longer to find the shortest path between two vertices, but to find the shortest k paths. So far, the reported KSP-algorithms only considers finding shortest k paths with regard to a single criterion, while far more application scenarios of the KSP require to determine k paths by taking more criteria into account. This article formulates the KSP as a multi-objective optimization problem. In consideration of the problem's property and genetic algorithm's great success in multi-objective optimization, the genetic algorithm is utilized as the optimization tool. The genotype is directly represented as the form of natural routing. In order to make the related genetic operators risk-free, the conception of gene-bank is introduced. And the crossover and mutation are both implemented based on the introduced gene-bank. The proposed genetic algorithm is tested on an undirected graph of 9-vertex/65-edge. The testing result shows that, our proposed algorithm is valid and outperforms some other swarm intelligence-based algorithms in terms of the obtained paths' quality.
Read moreDistance Two Surjective Labelling of Paths and Interval Graphs
Graph labelling problem has been broadly studied for a long period for its applications, especially in frequency assignment in (mobile) communication system, X -ray crystallography, circuit design, etc. Nowadays, surjective L 2,1 -labelling is a well-studied problem. Motivated from the L 2,1 -labelling problem and the importance of surjective L 2,1 -labelling problem, we consider surjective L 2,1 -labelling ( SL 21 -labelling) problems for paths and interval graphs. For any graph G = V , E , an SL 21 -labelling is a mapping φ : V ⟶ 1,2 , … , n so that, for every pair of nodes u and v , if d u , v = 1 , then φ u − φ v ≥ 2 ; and if d u , v = 2 , then φ u − φ v ≥ 1 , and every label 1,2 , … , n is used exactly once, where d u , v represents the distance between the nodes u and v , and n is the number of nodes of graph G . In the present article, it is proved that any path P n can be surjectively L 2,1 -labelled if n ≥ 4 , and it is also proved that any interval graph IG G having n nodes and degree Δ > 2 can be surjectively L 2,1 -labelled if n = 3 Δ − 1 . Also, we have designed two efficient algorithms for surjective L 2,1 -labelling of paths and interval graphs. The results regarding both paths and interval graphs are the first result for surjective L 2,1 -labelling.
Read moreCache-Oblivious Buffer Heap and Cache-Efficient Computation of Shortest Paths in Graphs
We present the buffer heap , a cache-oblivious priority queue that supports Delete-Min , Delete , and a hybrid Insert / Decrease-Key operation in O (1/ B log 2 N / M ) amortized block transfers from main memory, where M and B are the (unknown) cache size and block size, respectively, and N is the number of elements in the queue. We introduce the notion of a slim data structure that captures the situation when only a limited portion of the cache, which we call a slim cache , is available to the data structure to retain data between data structural operations. We show that a buffer heap automatically adapts to such an environment and supports all operations in O (1/λ + 1/ B log 2 N /λ) amortized block transfers each when the size of the slim cache is λ. Our results provide substantial improvements over known trivial cache performance bounds for cache-oblivious priority queues with Decrease-Keys . Using the buffer heap, we present cache-oblivious implementations of Dijkstra’s algorithm for undirected and directed single-source shortest path (SSSP) problems for graphs with non-negative real edge-weights. On a graph with n vertices and m edges, our algorithm for the undirected case performs O ( n + m / B log 2 n / M ) block transfers and for the directed case performs O (( n + m / B ) ċ log 2 n / B ) block transfers. These results give the first non-trivial cache-oblivious bounds for the SSSP problem on general graphs. For the all-pairs shortest path (APSP) problem on weighted undirected graphs, we incorporate slim buffer heaps into multi-buffer-buffer-heaps and use these to improve the cache-aware cache complexity. We also present a simple cache-oblivious APSP algorithm for unweighted undirected graphs that performs O ( mn / B log M / B n / B ) block transfers. This matches the cache-aware bound and is a substantial improvement over the previous cache-oblivious bound for the problem.
Read morePoly-logarithmic Approximation for Maximum Node Disjoint Paths with Constant Congestion
We consider the Maximum Node Disjoint Paths (MNDP) problem in undirected graphs. The input consists of an undirected graph G = (V, E) and a collection {(s1, t1), …, (sk, tk)} of k source-sink pairs. The goal is to select a maximum cardinality subset of pairs that can be routed/connected via node-disjoint paths. A relaxed version of MNDP allows up to c paths to use a node, where c is the congestion parameter. We give a polynomial time algorithm that routes Ω(OPT/poly log k) pairs with O(1) congestion, where OPT is the value of an optimum fractional solution to a natural multicommodity flow relaxation. Our result builds on the recent breakthrough of Chuzhoy [17] who gave the first poly-logarithmic approximation with constant congestion for the Maximum Edge Disjoint Paths (MEDP) problem.
Read moreThe Shortest Path Problem for a Multiple Graph
In the article, the definition of an undirected multiple graph of any natural multiplicity $$k > 1$$ is stated. There are edges of three types: ordinary edges, multiple edges, and multi-edges. Each edge of the last two types is the union of $$k$$ linked edges, which connect 2 or $$k + 1$$ vertices, correspondingly. The linked edges should be used simultaneously. If a vertex is incident to a multiple edge, it can be also incident to other multiple edges and it can be the common ending vertex to $$k$$ linked edges of some multi-edge. If a vertex is the common end of a multi-edge, it cannot be the common end of any other multi-edge. Also, a class of the divisible multiple graphs is considered. The main peculiarity of them is a possibility to divide the graph into $$k$$ parts, which are adjusted on the linked edges and which have no common ordinary edges. Each part is an ordinary graph. The following terms are generalized: the degree of a vertex, connectedness of a graph, the path, the cycle, the weight of an edge, and the path length. The definition of a reachability set for the ordinary and multiple edges is stated. The adjacency property is defined for a pair of reachability sets. It is shown, that we can check the connectedness of a multiple graph with the polynomial algorithm based on the search for reachability sets and testing their adjacency. A criterion of the existence of a multiple path between two given vertices is considered. The shortest multiple path problem is stated. Then, we suggest an algorithm for finding the shortest path in a multiple graph. It uses Dijkstra’s algorithm for finding the shortest paths in subgraphs, which correspond to different reachability sets.
Read moreFinding Hamiltonian and Longest (s,t)-Paths of C-Shaped Supergrid Graphs in Linear Time
A graph is called Hamiltonian connected if it contains a Hamiltonian path between any two distinct vertices. In the past, we proved the Hamiltonian path and cycle problems for general supergrid graphs to be NP-complete. However, they are still open for solid supergrid graphs. In this paper, first we will verify the Hamiltonian cycle property of C-shaped supergrid graphs, which are a special case of solid supergrid graphs. Next, we show that C-shaped supergrid graphs are Hamiltonian connected except in a few conditions. For these excluding conditions of Hamiltonian connectivity, we compute their longest paths. Then, we design a linear-time algorithm to solve the longest path problem in these graphs. The Hamiltonian connectivity of C-shaped supergrid graphs can be applied to compute the optimal stitching trace of computer embroidery machines, and construct the minimum printing trace of 3D printers with a C-like component being printed.
Read moreDisjoint paths and connected subgraphs for H-free graphs
Disjoint paths and connected subgraphs for H-free graphs
All-or-Nothing Multicommodity Flow Problem with Bounded Fractionality in Planar Graphs
We study the following all-or-nothing multicommodity flow problem in planar graphs. Input: A graph G with n vertices and k pairs of vertices (s1, t1), (s2, t2),..., (sk, tk) in G. Find: A largest subset W of {1, ...., k such that for every i in W, we can send one unit of flow between si and ti. This problem is different from the well-known maximum edge-disjoint paths problem in that we do not require integral flows for the pairs. This problem is APX-hard even for trees, and a 2-approximation algorithm is known for trees. For general graphs, Chekuri et al. (STOC'04) give a poly-logarithmic factor approximation algorithm and show that a natural LP-relaxation has a poly-logarithmic integrality gap. This result is in contrast with the integrality gap Ω(√n) for the maximum edge-disjoint paths problem. Our main result considerably strengthens this result when an input graph is planar. Namely, for the all-or-nothing multicommodity flow problem in planar graphs, we give an O(1)-approximation algorithm and show that the integrality gap is O(1). In particular, in polynomial time, we can find an index set W with |W| = Ω(OPT) and eight si-ti paths for each i in W such that each edge is used at most eight times in these paths (with multiplicity), where OPT is the optimal value of the LP-relaxation of the all-or-nothing multicommodity flow problem. Our result can be compared to the recent result by S'eguin-Charbonneau and Shepherd (FOCS'11) who give an O(1)-approximation algorithm for the maximum edge-disjoint paths problem in planar graphs with congestion 2 (but not implied by this result).
Read moreAn approximation algorithm for the longest path problem in solid grid graphs
The longest path problem is a well-known NP-hard problem which can be used to model and solve some optimization problems. There are only a few classes of graphs for which this problem can be solved polynomially. In addition, the results show that the problem is hard to approximate within any reasonable factor for general graphs. We introduce a polynomial-time -approximation algorithm for the longest path problem in solid grid graphs. Our algorithm can also approximate the longest path between any two given boundary vertices of a solid grid graph within the same approximation factor.
Read moreThe all-or-nothing multicommodity flow problem
We consider the all-or-nothing multicommodity flow problem in general graphs. We are given a capacitated undirected graph G=(V,E,u) and set of k pairs s1t1, s2t2, …, sktk. Each pair has a unit demand. The objective is to find a largest subset S of 1,2,…,k such that for every i in S we can send a flow of one unit between si and ti. Note that this differs from the edge-disjoint path problem (EDP) in that we do not insist on integral flows for the pairs. This problem is NP-hard, and APX-hard, even on trees. For trees, a 2--approximation is known for the cardinality case and a 4--approximation for the weighted case. In this paper we build on a recent result of Racke on low congestion oblivious routing in undirected graphs to obtain a poly-logarithmic approximation for the all-or-nothing problem in general undirected graphs. The best previous known approximation for all-or-nothing flow problem was O(min(n
Read more